﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data;
using System.Data.SqlClient;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.ServiceModel.Activation;
using System.ServiceModel.Web;
using System.Text;
using Telerik.Web.UI;

[ServiceContract(Namespace = "")]
[AspNetCompatibilityRequirements(RequirementsMode = AspNetCompatibilityRequirementsMode.Allowed)]
public class LoadEntriesWCF
{
	// To use HTTP GET, add [WebGet] attribute. (Default ResponseFormat is WebMessageFormat.Json)
	// To create an operation that returns XML,
	//     add [WebGet(ResponseFormat=WebMessageFormat.Xml)],
	//     and include the following line in the operation body:
	//         WebOperationContext.Current.OutgoingResponse.ContentType = "text/xml";
	[OperationContract]
	public void DoWork()
	{
		// Add your operation implementation here
		return;
	}


    [OperationContract]
    public SearchBoxItemData[] GetResults(SearchBoxContext context)
    {
        DataTable data = GetData(context.Text);

        List<SearchBoxItemData> result = new List<SearchBoxItemData>();

        for (int i = 0; i < data.Rows.Count; i++)
        {
            SearchBoxItemData itemData = new SearchBoxItemData();
            itemData.Text = data.Rows[i]["ProductName"].ToString();
            itemData.Value = data.Rows[i]["ProductId"].ToString();

            result.Add(itemData);
        }

        return result.ToArray();
    }

    private static DataTable GetData(string filterString)
    {
        SqlConnection connection = new SqlConnection(ConfigurationManager.ConnectionStrings["NorthwindConnectionString"].ConnectionString);
        SqlCommand command = new SqlCommand("SELECT [ProductId], [ProductName] FROM [Products] WHERE [ProductName] LIKE '%' + @filterString + '%' ORDER BY [ProductId]");
        command.Parameters.AddWithValue("@filterString", filterString);
        command.Connection = connection;
        SqlDataAdapter adapter = new SqlDataAdapter(command);

        DataTable data = new DataTable();
        adapter.Fill(data);
        return data;
    }

	// Add more operations here and mark them with [OperationContract]
}
